<?php
require_once("utilities.php");
require_once('facebook_app.php');
FacebookApp::instance()->ensureFacebookUserLoggedInToVB();
require_once('category.php');
final class CategoryList {
    private $firstList;
    // + Singleton implementation
    private static $instance = null;
    public static function instance() {
        if(!isset(self::$instance)) {
            self::$instance = new CategoryList();
        }
        return self::$instance;
    }
	private function __construct() {
        
    }
    // - Singleton implementation
    
    private $ad_index = 1;
    private $num_categories = 3;
	private $num_data_items_per_category = 3;
    
    public function renderList($rest = null) {       
        $categories = array();
        $first_page = Category::first_page();
	
		usort($first_page, array("CategoryList", "category_sorter2"));
	
		$data_items_hash = array();
	
        foreach($first_page as $category) {
			$category_name = $category->getCategoryName();			
			$items = array();
			$i = 0;
			foreach($category->getData() as $data_item) {
				if($i >= $this->num_data_items_per_category) break;
				
				$contenttype = Category::registry($data_item->getCategory())->getContenttype();
				$id = $data_item->getId();				
				if(!isset($data_items_hash[$contenttype][$id])) {
					$data_items_hash[$contenttype][$id] = true;
					$i++;
					$items[] = $data_item;
				}
			}
			$categories[$category_name]['items'] = $items;
			$categories[$category_name]['weight'] = Category::registry($category_name)->getRelevance($items);
		}
        uasort($categories, array("CategoryList", "category_sorter"));

        $i = 0;
        $ad_code = $this->getAdCode();
        foreach($categories as $category_name => $category) {         
			if($i++ == $this->ad_index && !empty($ad_code)) {
                echo Category::registry($category_name)->getSmallDashboardHtml($category['items']);
                echo '<div class="box_ad">'. $ad_code .'</div>';               
            } else {
                if($i <= $this->num_categories)
                    echo Category::registry($category_name)->getDashboardHtml($category['items']);
                else{
                    $category['items']['display_category'] = 'none';
                    echo Category::registry($category_name)->getDashboardHtml($category['items']);
                }
            }
            echo '<div class="clear"></div>';
        }
        $expires = Category::expires($first_page);
        return $expires;
    }
	
	private function category_sorter($category1, $category2) {
		$weight1 = $category1['weight'];
        $weight2 = $category2['weight'];
        if($weight1 > $weight2) return -1;
        else if($weight1 == $weight2) return 0;
        else return 1;
    }
	private function category_sorter2($category1, $category2) {
		$weight1 = $category1->getWeight();
        $weight2 = $category2->getWeight();
        if($weight1 > $weight2) return -1;
        else if($weight1 == $weight2) return 0;
        else return 1;
    }
    
    private function getAdCode() {
        return defined('BOX_AD') ? BOX_AD : '';
    }
}
if(!isset($_GET['do'])) {
    display_header();
?>
<div id="dbcontent">
    <div id="box_view" class="list">
        <?php $expires = CategoryList::instance()->renderList(); ?>
        <div id="div_show_rest" align="center"><a href="#" onclick="showAllCategories(); return false;">Show/Hide Other Categories</a></div>
    </div>
</div>
<?php 
    display_footer($expires);
} else if ($_GET['do'] == 'update') {
    cache_start();
    cache_end(CategoryList::instance()->renderList());
}
?>

